#!/usr/bin/env python
# generated by wxGlade 0.2.3 on Sun Sep 21 20:14:53 2003

"""Kiki - a Free Environment for Regular Expression Testing (ferret)

Copyright (C) 2003 Project 5

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

Contact info
web: http://come.to/project5
mail/msn: project5@operamail.com
icq: 84243714
"""

from wxPython.wx import *
from wxPython.html import *

__version__ = "0.1"

import re, os, os.path, cgi

# string constants
WINDOWSIZE = "MainWindowSize"
WINDOWPOSITION = "MainWindowPosition"
SASHPOSITION = "SashPosition"
SEARCHTYPE = "SearchType"

SAMPLETEXT = "SampleText"
REGEX = "Regex"

RESULTS_SHOWSAMPLE = "ShowSampleTextInResults"

# flags below are used in settings and in eval() function, so do NOT change!
FLAGIGNORE = "re.IGNORECASE"
FLAGMULTILINE = "re.MULTILINE"
FLAGLOCALE = "re.LOCALE"
FLAGDOTALL = "re.DOTALL"
FLAGUNICODE = "re.UNICODE"
FLAGVERBOSE = "re.VERBOSE"

# constants required by the GUI
ni = wxNewId
ID_EVALUATE = ni()

# global variable
settings = None

# templates
t_error = """<font color="maroon"><b>Error:</b></font><br /><ul>%s</ul>"""
t_nomatch = """<font color="teal"><b>No match found</b></font>"""

# colors used to highlight matches
colors = ["0000AA" , "00AA00" , "FFAA55" , "AA0000" , "00AAAA" , "AA00AA" , "AAAAAA" ,
          "0000FF" , "00FF00" , "00FFFF" , "FF0000" , "DDDD00" , "FF00FF" ,
          "AAAAFF" , "FF55AA" , "AAFF55" , "FFAAAA" , "55AAFF" , "FFAAFF" ,
          "000077" , "007700" , "770000" , "007777" , "770077" , "777700" ]

class Settings(object):
    """Stores and retrieves settings to a file as Python data
       structures which are eval()-ed. This is not by definition
       safe, but since the user has access to source code anyway
       and hence the ability to screw up anything, the danger
       seems quite limited."""
    def __init__(self, savedir=None, dirname="", filename="settings.py", debugfile=""):
        """Initializes the object

           Arguments:
           savedir -- directory where to store data
                      For more info, see the docs of Settings.setSaveDir()
           dirname -- if savedir=None, dirname is used to determine which
                      subdirectory of $HOME data is stored it.
           filename -- name of file containing stored data
           debugfile -- used to allow the user to manually override the
                        default storage dir. Mor info in the docs of
                        Settings.setSaveDir()
        """
        self.__setSaveDir(savedir, dirname, debugfile)
        self.savefilename = filename
        self.__load()

    def shutdown(self):
        """Must be called before the program ends."""
        self.save()

    def __setSaveDir(self, savedir=None, dirname="", debugfile=""):
        """Sets self.savedir

           Arguments:
           savedir -- directory where to store data
                      if savedir==None, $HOME/dirname is used.
                      If necessary, the directory is created.
           dirname -- if savedir==None, dirname determines which
                      subdirectory of the home dir data is stored
                      in
           debugfile -- this file may be a filename which is imported
                        and may contain a variable called savedir
                        If the debugfile is specified, imported
                        successfully and savedir exists, it is used
                        to override any other parameters. This allows
                        users to override the directory, bypassing
                        the application which needs the settings.

           In some Windows installations (seems to be mainly a Win2k
           problem), $HOME points to the root directory. In this case,
           this function will try to use $USERPROFILE/dirname instead.

           Overriding this default behaviour is possible by supplying the
           savedir variable in pearsdebug.py."""
        if savedir==None:
            try: # try to override using debugfile if present and contains savedir
                debugmodule = __import__(debugfile, globals())
                savedir = debugmodule.savedir
            except: # if no override, then perform default actions
                if savedir == None: # use $HOME/dirname
                    savedir = os.path.expanduser('~/'+dirname)
                    if len(savedir)<=len("c:\\/"+dirname): # sometimes $HOME points to root
                        # if this is the case, try using $USERPROFILE (see docstring)
                        temp = os.path.join(os.path.expandvars('$USERPROFILE'), dirname)
                        # if this is a different location, use it!
                        if temp > len("C:\\/"+dirname):
                            savedir = temp
            # create dir if it doesn't exist
        if not os.path.exists(savedir):
            os.makedirs(savedir)
        self.savedir = savedir

    def __load(self):
        """Loads the settings from a file. These settings are saved
           in Python code format which is eval()-ed, so it's not
           trustworthy."""
        try:
            settingsfile = file(os.path.join(self.savedir, self.savefilename), "r")
            self.settings = eval(settingsfile.read())
            settingsfile.close()
        except: # if file doesn't exist
            self.settings= {}

    def save(self):
        """Saves the settings to a file."""
        settingsfile = file(os.path.join(self.savedir, self.savefilename), "w")
        settingsfile.write(str(self.settings))
        settingsfile.close()

    def set(self, settingname, value):
        """Changes the value of a setting with settingname to value."""
        self.settings[settingname] = value

    def get(self, settingname, defaultval=None):
        """Returns the setting with settingname if present, otherwise
           returns defaultval and saves settingname with defaultval."""
        if self.settings.has_key(settingname):
            return self.settings[settingname]
        else:
            self.set(settingname, defaultval)
            return defaultval


class MyFrame(wxFrame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wxDEFAULT_FRAME_STYLE
        wxFrame.__init__(self, *args, **kwds)
        self.SplitterWindow = wxSplitterWindow(self, -1, style=wxSP_3D|wxSP_LIVE_UPDATE)
        self.BottomPane = wxPanel(self.SplitterWindow, -1)
        self.Notebook = wxNotebook(self.BottomPane, -1, style=0)
        self.HelpPane = wxPanel(self.Notebook, -1)
        self.SampleTextPane = wxPanel(self.Notebook, -1)
        self.MatchesPane = wxPanel(self.Notebook, -1, style=wxSUNKEN_BORDER|wxTAB_TRAVERSAL)
        self.TopPane = wxPanel(self.SplitterWindow, -1, style=wxRAISED_BORDER|wxTAB_TRAVERSAL)
        self.RegexBox = wxComboBox(self.TopPane, -1, choices=["", "", "", "", "", "", ""], style=wxCB_DROPDOWN)
        self.EvaluateButton = wxButton(self.TopPane, ID_EVALUATE, "Evaluate")
        self.MethodBox = wxRadioBox(self.TopPane, -1, "Methods", choices=["Find all", "Find first"], majorDimension=1, style=wxRA_SPECIFY_COLS)
        self.IgnoreCheckBox = wxCheckBox(self.TopPane, -1, "IGNORECASE (I)")
        self.MultilineCheckBox = wxCheckBox(self.TopPane, -1, "MULTILINE (M)")
        self.LocaleCheckBox = wxCheckBox(self.TopPane, -1, "LOCALE (L)")
        self.DotAllCheckBox = wxCheckBox(self.TopPane, -1, "DOTALL (S)")
        self.UnicodeCheckBox = wxCheckBox(self.TopPane, -1, "UNICODE (U)")
        self.VerboseCheckBox = wxCheckBox(self.TopPane, -1, "VERBOSE (X)")
        self.MatchesWindow = wxHtmlWindow(self.MatchesPane, -1)
        self.SampleText = wxTextCtrl(self.SampleTextPane, -1, "", style=wxTE_PROCESS_TAB|wxTE_MULTILINE|wxTE_RICH)
        self.HelpSelection = wxComboBox(self.HelpPane, -1, choices=["Working with Kiki", "Re - syntax", "Re - special characters", "Re - special sequences", "Re - options", "About Kiki"], style=wxCB_DROPDOWN|wxCB_READONLY)
        self.HelpWindow = wxHtmlWindow(self.HelpPane, -1)

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("Kiki")
        self.SetSize((640, 480))
        self.RegexBox.SetSelection(0)
        self.EvaluateButton.SetDefault()
        self.MethodBox.SetToolTipString("Find all returns all matches, find first only the first one")
        self.MethodBox.SetSelection(0)
        self.IgnoreCheckBox.SetToolTipString("Perform case-insensitive matching\nExpressions like [A-Z] will match lowercase letters too. This is not affected by the current locale.")
        self.MultilineCheckBox.SetToolTipString("When specified, the pattern characters \"^\" and \"$\" match at the beginning respectively end of the string and at the beginning respectively end of each line (immediately following respectively preceding each newline).\nOtherwise \"^\" matches only at the beginning of the string, and \"$\" only at the end of the string and immediately before the newline (if any) at the end of the string.")
        self.LocaleCheckBox.SetToolTipString("Make \w, \W, \\b, and \B dependent on the current locale.")
        self.DotAllCheckBox.SetToolTipString("Make the \".\" special character match any character at all, including a newline. Without this flag, \".\" will match anything except a newline.")
        self.UnicodeCheckBox.SetToolTipString("Make \w, \W, \\b, and \B dependent on the Unicode character properties database.")
        self.VerboseCheckBox.SetToolTipString("This flag allows you to write regular expressions that look nicer.\nWhitespace within the pattern is ignored, except when in a character class or preceded by an unescaped backslash, and, when a line contains a \"#\" neither in a character class or preceded by an unescaped backslash, all characters from the leftmost such \"#\" through the end of the line are ignored. ")
        self.HelpSelection.SetSelection(0)
        self.BottomPane.SetSize((623, 324))
        self.SplitterWindow.SplitHorizontally(self.TopPane, self.BottomPane, 120)
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        MainSizer = wxBoxSizer(wxHORIZONTAL)
        TopPaneSizer = wxBoxSizer(wxHORIZONTAL)
        HelpPaneSizer = wxFlexGridSizer(3, 1, 7, 7)
        SampleTextSizer = wxBoxSizer(wxHORIZONTAL)
        MatchesPaneSizer = wxBoxSizer(wxHORIZONTAL)
        BottomPaneSizer = wxFlexGridSizer(5, 3, 0, 0)
        OptionsSizer = wxFlexGridSizer(1, 2, 0, 7)
        FlagsSizer = wxStaticBoxSizer(wxStaticBox(self.TopPane, -1, "Flags"), wxHORIZONTAL)
        FlagCheckSizer = wxFlexGridSizer(4, 3, 7, 15)
        RegexSizer = wxFlexGridSizer(1, 2, 0, 7)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        RegexSizer.Add(self.RegexBox, 0, wxEXPAND, 0)
        RegexSizer.Add(self.EvaluateButton, 0, 0, 0)
        RegexSizer.AddGrowableCol(0)
        BottomPaneSizer.Add(RegexSizer, 1, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        OptionsSizer.Add(self.MethodBox, 0, wxEXPAND, 0)
        FlagCheckSizer.Add(7, 2, 0, wxEXPAND, 0)
        FlagCheckSizer.Add(7, 2, 0, wxEXPAND, 0)
        FlagCheckSizer.Add(7, 2, 0, wxEXPAND, 0)
        FlagCheckSizer.Add(self.IgnoreCheckBox, 0, 0, 0)
        FlagCheckSizer.Add(self.MultilineCheckBox, 0, 0, 0)
        FlagCheckSizer.Add(self.LocaleCheckBox, 0, 0, 0)
        FlagCheckSizer.Add(self.DotAllCheckBox, 0, 0, 0)
        FlagCheckSizer.Add(self.UnicodeCheckBox, 0, 0, 0)
        FlagCheckSizer.Add(self.VerboseCheckBox, 0, 0, 0)
        FlagCheckSizer.Add(7, 2, 0, wxEXPAND, 0)
        FlagCheckSizer.Add(7, 2, 0, wxEXPAND, 0)
        FlagCheckSizer.Add(7, 2, 0, wxEXPAND, 0)
        FlagsSizer.Add(FlagCheckSizer, 1, wxEXPAND, 0)
        OptionsSizer.Add(FlagsSizer, 1, 0, 0)
        BottomPaneSizer.Add(OptionsSizer, 1, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        BottomPaneSizer.Add(7, 7, 0, wxEXPAND, 0)
        self.TopPane.SetAutoLayout(1)
        self.TopPane.SetSizer(BottomPaneSizer)
        BottomPaneSizer.Fit(self.TopPane)
        BottomPaneSizer.SetSizeHints(self.TopPane)
        BottomPaneSizer.AddGrowableCol(1)
        MatchesPaneSizer.Add(self.MatchesWindow, 1, wxEXPAND, 0)
        self.MatchesPane.SetAutoLayout(1)
        self.MatchesPane.SetSizer(MatchesPaneSizer)
        MatchesPaneSizer.Fit(self.MatchesPane)
        MatchesPaneSizer.SetSizeHints(self.MatchesPane)
        SampleTextSizer.Add(self.SampleText, 1, wxEXPAND, 0)
        self.SampleTextPane.SetAutoLayout(1)
        self.SampleTextPane.SetSizer(SampleTextSizer)
        SampleTextSizer.Fit(self.SampleTextPane)
        SampleTextSizer.SetSizeHints(self.SampleTextPane)
        HelpPaneSizer.Add(1, 1, 0, wxEXPAND, 0)
        HelpPaneSizer.Add(self.HelpSelection, 0, wxEXPAND, 0)
        HelpPaneSizer.Add(self.HelpWindow, 1, wxEXPAND, 0)
        self.HelpPane.SetAutoLayout(1)
        self.HelpPane.SetSizer(HelpPaneSizer)
        HelpPaneSizer.Fit(self.HelpPane)
        HelpPaneSizer.SetSizeHints(self.HelpPane)
        HelpPaneSizer.AddGrowableRow(2)
        HelpPaneSizer.AddGrowableCol(0)
        self.Notebook.AddPage(self.MatchesPane, "Matches")
        self.Notebook.AddPage(self.SampleTextPane, "Sample text")
        self.Notebook.AddPage(self.HelpPane, "Help")
        TopPaneSizer.Add(wxNotebookSizer(self.Notebook), 1, wxEXPAND, 0)
        self.BottomPane.SetAutoLayout(1)
        self.BottomPane.SetSizer(TopPaneSizer)
        MainSizer.Add(self.SplitterWindow, 1, wxEXPAND, 0)
        self.SetAutoLayout(1)
        self.SetSizer(MainSizer)
        self.Layout()
        self.Centre()
        # end wxGlade

# end of class MyFrame

class MyFrameWithEvents(MyFrame):
    """Subclasses MyFrame - generated by wxGlade - and adds events."""
    def __init__(self, *args, **kwargs):
        MyFrame.__init__(self, *args, **kwargs)

        # map option flags to checkboxes
        self.flagmapper = {FLAGIGNORE: self.IgnoreCheckBox,
                           FLAGMULTILINE: self.MultilineCheckBox,
                           FLAGLOCALE: self.LocaleCheckBox,
                           FLAGDOTALL: self.DotAllCheckBox,
                           FLAGUNICODE: self.UnicodeCheckBox,
                           FLAGVERBOSE: self.VerboseCheckBox}

        # set empty pages for HTML windows
        self.MatchesWindow.SetPage("")
        self.HelpWindow.SetPage("")
        self.HelpWindow.SetWindowStyleFlag(wxSUNKEN_BORDER)

        self.Notebook.SetSelection(0)
        self.RegexBox.Clear()

        # bind events
        wx.EVT_BUTTON(self, ID_EVALUATE, self.evaluate)
        wx.EVT_CLOSE(self, self.close)

        # apply settings
        self.loadSettings()

        # move focus to regex input field
        self.RegexBox.SetFocus()

        # initialize needed attribs
        self.matches = [] # list of found matches

    def evaluate(self, event):
        """Actual functionality, triggered by Evaluate button press.

           The regex is compiled if possible.
           If compilation is successful, the regex is added to the
           history and it's matched against the sample text.
           If compilation is unsuccessful, the error message is
           displayed.
        """
        self.Notebook.SetSelection(0) # display output pane
        # STEP 1: try to compile the regex
        # get flags to use in the compilation
        flags = 0
        for flag in self.flagmapper.keys():
            if self.flagmapper[flag].IsChecked():
                flags = flags|eval(flag)
        # compile the regex and stop with error message if invalid
        try:
            self.MatchesWindow.SetPage("")
            regex = re.compile(self.RegexBox.GetValue())
        except re.error, e:
            self.MatchesWindow.SetPage(t_error % e)
            return False # stop execution if error

        if self.RegexBox.GetValue().strip(): # append to history
            # get current history items
            currentitems = [self.RegexBox.GetValue()]
            for i in range(self.RegexBox.GetCount()):
                t = self.RegexBox.GetString(0)
                if not t in currentitems: # no duplicates
                    currentitems.append(t)
                self.RegexBox.Delete(0)
            for item in currentitems:
                self.RegexBox.Append(item)

        rawtext = self.SampleText.GetValue()
        self.matches = [] # empty the list of match objects
        output = []
        while 1:
            if len(self.matches)==0:
                start = 0
            else:
                start = self.matches[-1].end()
            match = regex.search(rawtext, start)
            if (not match) or \
               (len(self.matches)>=1 and self.MethodBox.GetSelection()==1):
                break # stop execution
            else:
                self.matches.append(match)
        if not self.matches: # if no matches found
            output.append(t_nomatch)
        else: # matches found
            output.append(self.report())
        if settings.get(RESULTS_SHOWSAMPLE, True):
            output.append("""<br /><br /><table cellpadding="0" cellspacing="0"><tr><td>
                               <b>Sample text matched against:</b>
                             </td></tr>
                             <tr><td bgcolor="#EEEEEE"><i>""")
            output.append(self.htmlize(rawtext) or "&nbsp;") # something must be in there, so if no raw text, at least force a space
            output.append("</i></td></tr></table>")
        self.MatchesWindow.SetPage("".join(output))

    def htmlize(self, text):
        """Converts the text to html (escapes HTML entities and tags,
           converts spaces to &nbsp's and enters to <br>'s."""
        result = cgi.escape(text)
        result = result.replace("\t", "&nbsp;&nbsp;&nbsp;&nbsp;")
        result = result.replace(" ", "&nbsp;")
        result = result.replace("\r\n", "<br />")
        result = result.replace("\r", "<br />")
        result = result.replace("\n", "<br />")
        return result

    def report(self):
        """Converts the results to html code and returns that.
           Is not capable of handling an empty self.matches list of matches."""
        if not self.matches:
            raise ValueError, "self.matches must be non-empty list of re match opbjects"
        index = -1 # number of current match that's being printed
        html = []
        html.append("""<table cellpadding="0" cellspacing="0"><tr><td bgcolor="#F8F8F8">""")
        for match in self.matches:
            index += 1
            # determine what part of the string we're looking at
            if index>0:
                prevmatchend = self.matches[index-1].end()
            else:
                prevmatchend = 0
            if index+1 < len(self.matches):
                nextmatchstart = self.matches[index+1].start()
            else:
                nextmatchstart = -1
            html.append(self.htmlize(match.string[prevmatchend:match.start()]))
            html.append("<b>(</b><i>")
            html.append(self.htmlize(match.string[match.start():match.end()]))
            html.append("</i><b>)</b>")
            if index+1 >= len(self.matches): # if last match, print rest of string
                html.append(self.htmlize(match.string[match.end():nextmatchstart]))
        html.append("""</td></tr></table>""")
        return "".join(html)


	#~ start = self.reportResult(m, text, 0)
	#~ if self.findall.get():
	    #~ while start < len(text):
		#~ m = r.search(text, start)
		#~ if not m: break
		#~ start = self.reportResult(m, text, start)
	#~ self.result.insert(END, text[start:])

    #~ def reportResult(self, m, text, start):
	#~ boundchars = "()"
	#~ bounds = []
	#~ for i in range(0, len(m.groups())+1):
	    #~ s,e = m.start(i), m.end(i)
	    #~ if s == -1 or e == -1: continue
	    #~ bounds.append((s, 0))
	    #~ bounds.append((e, 1))
	#~ bounds.sort(lambda s1, s2: s1[0] - s2[0])
	#~ index = start
	#~ for b in bounds:
	    #~ bindex = b[0]
	    #~ self.result.insert(END, text[index:bindex])
	    #~ self.result.insert(END, boundchars[b[1]], 'bold')
	    #~ index = bindex
	#~ if m.start() == m.end():
	    #~ if index < len(text):
		#~ self.result.insert(END, text[index])
	    #~ index = index + 1
	#~ return index

    def loadSettings(self):
        """Loads GUI settings from the settings system."""
        # load some size settings
        # set window size and position; make sure it's on screen
        # and has a reasonable size
        system = wx.wxSystemSettings_GetMetric
        pos = list(settings.get(WINDOWPOSITION, (-1,-1)))
        if pos[0]<-1: pos[0] = 0
        if pos[1]<-1: pos[1] = 0
        if pos[0]>system(wx.wxSYS_SCREEN_X)-50:
            pos[0] = 0
        if pos[1]>system(wx.wxSYS_SCREEN_Y)-50:
            pos[1] = 0
        self.SetPosition(pos)
        size = list(settings.get(WINDOWSIZE, (-1, -1)))
        if size[0]>system(wx.wxSYS_SCREEN_X):
            size[0] = 640
        if size[1]>system(wx.wxSYS_SCREEN_Y):
            size[1] = 480
        size[0] = max(size[0], 640)
        size[1] = max(size[1], 480)
        self.SetSize(size)

        # load the sample text and regex last used
        self.SampleText.SetValue(settings.get(SAMPLETEXT, ""))
        self.RegexBox.SetValue(settings.get(REGEX, ""))

        # load the flags and desired type of re functionality
        for flag in self.flagmapper.keys():
            self.flagmapper[flag].SetValue(settings.get(flag, False))
        self.MethodBox.SetSelection(settings.get(SEARCHTYPE, 0))

        # other settings
        self.SplitterWindow.SetSashPosition(settings.get(SASHPOSITION, 100))

    def saveSettings(self, dosave=True):
        """Puts all GUI settings in the settings system.

           Arguments:
           dosave -- if True, the save() method of Settings is called
                     when done
        """
        # put all stuff that needs saving in the settings
        settings.set(WINDOWSIZE, self.GetSize())
        settings.set(WINDOWPOSITION, self.GetPosition())
        settings.set(SASHPOSITION, self.SplitterWindow.GetSashPosition())

        settings.set(SAMPLETEXT, self.SampleText.GetValue())
        settings.set(REGEX, self.RegexBox.GetValue())

        # save the selected flags
        for flag in self.flagmapper.keys():
            settings.set(flag, self.flagmapper[flag].GetValue())
        settings.set(SEARCHTYPE, self.MethodBox.GetSelection())

        if dosave: settings.save()

    def close(self, event):
        """Prepares for shutdown and then closes the app."""
        self.saveSettings()

        # shut down the settings system
        settings.shutdown()

        # shut down the app
        self.Destroy()

#~ class MyApp(wxApp):
    #~ def OnInit(self):
        #~ wxInitAllImageHandlers()
        #~ KikiWindow = MyFrameWithEvents(None, -1, "")
        #~ self.SetTopWindow(KikiWindow)
        #~ KikiWindow.Show(1)
        #~ return 1

# end of class MyApp

def speCreate(parent):
    """Integration of Kiki into spe (http://spe.pycs.net)"""
    global settings
    settings = Settings(dirname=".spe", filename="kikicfg.py", debugfile="kikidebug")
    Kiki = MyFrameWithEvents(parent, -1, "")
    Kiki.Show(1)



if __name__ == "__main__":
    settings = Settings(dirname=".kiki", filename="kikicfg.py", debugfile="kikidebug")
    #Kiki = MyApp()
    Kiki = wx.wxPySimpleApp()
    wx.wxInitAllImageHandlers()
    mw = MyFrameWithEvents(None, -1, "")
    # make sure the window isn't tiny
    Kiki.SetTopWindow(mw)
    mw.Show(1)
    Kiki.MainLoop()